/// <reference types="node" />
import { Buffer } from 'buffer';
import { TxMsg } from './tx-msg';
/**
 * MsgProtoAppTransfer is a special case of MsgProtoAppStake where
 * chains and amount are not set
 */
export declare class MsgProtoAppTransfer extends TxMsg {
    readonly KEY: string;
    readonly AMINO_KEY: string;
    readonly pubKey: Buffer;
    /**
     * Constructor for this class
     * @param {Buffer} pubKey - Application public key to be transferred to
     */
    constructor(pubKey: string);
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {object} - Msg type key value.
     * @memberof MsgAppStake
     */
    toStdSignDocMsgObj(): object;
    /**
     * Converts an Msg Object for StdTx encoding
     * @returns {any} - Msg type key value.
     * @memberof MsgAppStake
     */
    toStdTxMsgObj(): any;
}
//# sourceMappingURL=msg-proto-app-transfer.d.ts.map