import { TxMsg } from './tx-msg';
/**
 * Model representing a MsgAppStake to unstake an Application in the Pocket Network
 */
export declare class MsgProtoAppUnstake extends TxMsg {
    readonly KEY: string;
    readonly AMINO_KEY: string;
    readonly appAddress: string;
    /**
     * The address hex of the Application to unstake for
     * @param {string} appAddress - Application address
     */
    constructor(appAddress: string);
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {object} - Msg type key value.
     * @memberof MsgAppUnstake
     */
    toStdSignDocMsgObj(): object;
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {any} - Msg type key value.
     * @memberof MsgAppUnstake
     */
    toStdTxMsgObj(): any;
}
//# sourceMappingURL=msg-proto-app-unstake.d.ts.map