import { TxMsg } from './tx-msg';
import { GovParameter } from '../gov';
/**
 * Model representing a MsgGovChangeParam to change an existing governance parameter
 */
export declare class MsgProtoGovChangeParam extends TxMsg {
    readonly fromAddress: string;
    readonly paramKey: string;
    readonly paramValue: string;
    readonly KEY: string;
    readonly AMINO_KEY: string;
    /**
     * Constructor this message
     * @param {string} fromAddress - Origin address
     * @param {string} paramKey - the acl key for governance parameter
     * @param {string} paramValue - the plain text (ASCII) value the governance parameter will represent
     * @param {string} overrideGovParamsWhitelistValidation - In the event that the PocketJS does not support the specified paramKey, this parameter can be set to true to override the validation check.
     */
    constructor(fromAddress: string, paramKey: GovParameter | string, paramValue: string, overrideGovParamsWhitelistValidation?: boolean);
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {object} - Msg type key value.
     * @memberof MsgSend
     */
    toStdSignDocMsgObj(): object;
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {any} - Msg type key value.
     * @memberof MsgSend
     */
    toStdTxMsgObj(): any;
}
//# sourceMappingURL=msg-proto-gov-change-param.d.ts.map