import { TxMsg } from './tx-msg';
import { DAOAction } from '../gov';
/**
 * Model representing a MsgGovDAOTransfer to send POKT from the DAO Module Account to another account
 */
export declare class MsgProtoGovDAOTransfer extends TxMsg {
    readonly fromAddress: string;
    readonly toAddress: string;
    readonly amount: string;
    readonly KEY: string;
    readonly AMINO_KEY: string;
    readonly action: DAOAction;
    /**
     * Constructor this message
     * @param {string} fromAddress - DAOOwner Address
     * @param {string} toAddress - Destination address
     * @param {string} amount - Amount to be sent, needs to be a valid number greater than 0
     * @param {CoinDenom | undefined} amountDenom  - Amount value denomination
     * @param {DAOAction} action  - dao action to perform for transfers
     */
    constructor(fromAddress: string, toAddress: string, amount: string, action: DAOAction);
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {object} - Msg type key value.
     * @memberof MsgSend
     */
    toStdSignDocMsgObj(): object;
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {any} - Msg type key value.
     * @memberof MsgSend
     */
    toStdTxMsgObj(): any;
}
//# sourceMappingURL=msg-proto-gov-dao-transfer.d.ts.map