import { Upgrade } from './../proto/generated/tx-signer';
import { TxMsg } from './tx-msg';
/**
 * Model representing a MsgGovUpgrade to indicate an upgrade height for protocol updates, i.e consensus breaking changes
 */
export declare class MsgProtoGovUpgrade extends TxMsg {
    readonly fromAddress: string;
    readonly upgrade: Upgrade;
    readonly KEY: string;
    readonly AMINO_KEY: string;
    /**
     * Constructor this message
     * @param {string} fromAddress - Origin address
     * @param {string} upgrade - the upgrade details such as upgrade height and features being activated
     */
    constructor(fromAddress: string, upgrade: Upgrade);
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {object} - Msg type key value.
     * @memberof MsgSend
     */
    toStdSignDocMsgObj(): object;
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {any} - Msg type key value.
     * @memberof MsgSend
     */
    toStdTxMsgObj(): any;
}
//# sourceMappingURL=msg-proto-gov-upgrade.d.ts.map