import { TxMsg } from './tx-msg';
/**
 * Model representing a MsgNodeUnjail to unjail as an Node in the Pocket Network
 */
export declare class MsgProtoNodeUnjail extends TxMsg {
    readonly KEY: string;
    readonly AMINO_KEY: string;
    readonly nodeAddress: string;
    readonly signerAddress: string;
    /**
     * @param {string} nodeAddress - Node address to be unjailed
     * @param {string} signerAddress - Signer address (who triggered the unjail)
     */
    constructor(nodeAddress: string, signerAddress: string);
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {object} - Msg type key value.
     * @memberof MsgNodeUnjail
     */
    toStdSignDocMsgObj(): object;
    /**
     * Converts an Msg Object to StdTx
     * @returns {any} - Msg type key value.
     * @memberof MsgNodeUnjail
     */
    toStdTxMsgObj(): any;
}
//# sourceMappingURL=msg-proto-node-unjail.d.ts.map