import { TxMsg } from './tx-msg';
/**
 * Model representing a MsgSend to send POKT from one account to another
 */
export declare class MsgProtoSend extends TxMsg {
    readonly fromAddress: string;
    readonly toAddress: string;
    readonly amount: string;
    readonly KEY: string;
    readonly AMINO_KEY: string;
    /**
     * Constructor this message
     * @param {string} fromAddress - Origin address
     * @param {string} toAddress - Destination address
     * @param {string} amount - Amount to be sent, needs to be a valid number greater than 0
     * @param {CoinDenom | undefined} amountDenom  - Amount value denomination
     */
    constructor(fromAddress: string, toAddress: string, amount: string);
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {object} - Msg type key value.
     * @memberof MsgSend
     */
    toStdSignDocMsgObj(): object;
    /**
     * Converts an Msg Object to StdSignDoc
     * @returns {any} - Msg type key value.
     * @memberof MsgSend
     */
    toStdTxMsgObj(): any;
}
//# sourceMappingURL=msg-proto-send.d.ts.map