import _m0 from "protobufjs/minimal.js";
import { Any } from "./google/protobuf/any.js";
export declare const protobufPackage = "pocketjs";
export interface ProtoStdTx {
    msg: Any | undefined;
    fee: Coin[];
    signature: ProtoStdSignature | undefined;
    memo: string;
    entropy: number;
}
export interface ProtoStdSignature {
    publicKey: Uint8Array;
    Signature: Uint8Array;
}
export interface StdSignDoc {
    ChainID: string;
    fee: Uint8Array;
    memo: string;
    msg: Uint8Array;
    entropy: number;
}
export interface Coin {
    denom: string;
    amount: string;
}
/**
 * DecCoin defines a token with a denomination and a decimal amount.
 *
 * NOTE: The amount field is an Dec which implements the custom method
 * signatures required by gogoproto.
 */
export interface DecCoin {
    denom: string;
    amount: string;
}
export interface MsgProtoStake {
    pubKey: Uint8Array;
    chains: string[];
    value: string;
}
export interface MsgBeginUnstake {
    Address: Uint8Array;
}
export interface MsgUnjail {
    AppAddr: Uint8Array;
}
export interface MsgProtoNodeStake8 {
    Publickey: Uint8Array;
    Chains: string[];
    value: string;
    ServiceUrl: string;
    OutAddress: Uint8Array;
    RewardDelegators: {
        [key: string]: number;
    };
}
export interface MsgProtoNodeStake8_RewardDelegatorsEntry {
    key: string;
    value: number;
}
export interface MsgBeginNodeUnstake8 {
    Address: Uint8Array;
    Signer: Uint8Array;
}
export interface MsgNodeUnjail {
    ValidatorAddr: Uint8Array;
}
export interface MsgNodeUnjail8 {
    ValidatorAddr: Uint8Array;
    Signer: Uint8Array;
}
export interface MsgSend {
    FromAddress: Uint8Array;
    ToAddress: Uint8Array;
    amount: string;
}
export interface MsgDAOTransfer {
    fromAddress: Uint8Array;
    toAddress: Uint8Array;
    amount: string;
    action: string;
}
export interface Upgrade {
    height: number;
    version: string;
    oldUpgradeHeight: number;
    features: string[];
}
export interface MsgUpgrade {
    address: Uint8Array;
    upgrade: Upgrade | undefined;
}
export interface MsgChangeParam {
    FromAddress: Uint8Array;
    paramKey: string;
    paramVal: Uint8Array;
}
export declare const ProtoStdTx: {
    encode(message: ProtoStdTx, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): ProtoStdTx;
    fromJSON(object: any): ProtoStdTx;
    toJSON(message: ProtoStdTx): unknown;
    create<I extends {
        msg?: {
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } | undefined;
        fee?: {
            denom?: string | undefined;
            amount?: string | undefined;
        }[] | undefined;
        signature?: {
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } | undefined;
        memo?: string | undefined;
        entropy?: number | undefined;
    } & {
        msg?: ({
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } & {
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } & { [K in Exclude<keyof I["msg"], keyof Any>]: never; }) | undefined;
        fee?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        }[] & ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & { [K_1 in Exclude<keyof I["fee"][number], keyof Coin>]: never; })[] & { [K_2 in Exclude<keyof I["fee"], keyof {
            denom?: string | undefined;
            amount?: string | undefined;
        }[]>]: never; }) | undefined;
        signature?: ({
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } & {
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } & { [K_3 in Exclude<keyof I["signature"], keyof ProtoStdSignature>]: never; }) | undefined;
        memo?: string | undefined;
        entropy?: number | undefined;
    } & { [K_4 in Exclude<keyof I, keyof ProtoStdTx>]: never; }>(base?: I | undefined): ProtoStdTx;
    fromPartial<I_1 extends {
        msg?: {
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } | undefined;
        fee?: {
            denom?: string | undefined;
            amount?: string | undefined;
        }[] | undefined;
        signature?: {
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } | undefined;
        memo?: string | undefined;
        entropy?: number | undefined;
    } & {
        msg?: ({
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } & {
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } & { [K_5 in Exclude<keyof I_1["msg"], keyof Any>]: never; }) | undefined;
        fee?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        }[] & ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & { [K_6 in Exclude<keyof I_1["fee"][number], keyof Coin>]: never; })[] & { [K_7 in Exclude<keyof I_1["fee"], keyof {
            denom?: string | undefined;
            amount?: string | undefined;
        }[]>]: never; }) | undefined;
        signature?: ({
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } & {
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } & { [K_8 in Exclude<keyof I_1["signature"], keyof ProtoStdSignature>]: never; }) | undefined;
        memo?: string | undefined;
        entropy?: number | undefined;
    } & { [K_9 in Exclude<keyof I_1, keyof ProtoStdTx>]: never; }>(object: I_1): ProtoStdTx;
};
export declare const ProtoStdSignature: {
    encode(message: ProtoStdSignature, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): ProtoStdSignature;
    fromJSON(object: any): ProtoStdSignature;
    toJSON(message: ProtoStdSignature): unknown;
    create<I extends {
        publicKey?: Uint8Array | undefined;
        Signature?: Uint8Array | undefined;
    } & {
        publicKey?: Uint8Array | undefined;
        Signature?: Uint8Array | undefined;
    } & { [K in Exclude<keyof I, keyof ProtoStdSignature>]: never; }>(base?: I | undefined): ProtoStdSignature;
    fromPartial<I_1 extends {
        publicKey?: Uint8Array | undefined;
        Signature?: Uint8Array | undefined;
    } & {
        publicKey?: Uint8Array | undefined;
        Signature?: Uint8Array | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof ProtoStdSignature>]: never; }>(object: I_1): ProtoStdSignature;
};
export declare const StdSignDoc: {
    encode(message: StdSignDoc, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): StdSignDoc;
    fromJSON(object: any): StdSignDoc;
    toJSON(message: StdSignDoc): unknown;
    create<I extends {
        ChainID?: string | undefined;
        fee?: Uint8Array | undefined;
        memo?: string | undefined;
        msg?: Uint8Array | undefined;
        entropy?: number | undefined;
    } & {
        ChainID?: string | undefined;
        fee?: Uint8Array | undefined;
        memo?: string | undefined;
        msg?: Uint8Array | undefined;
        entropy?: number | undefined;
    } & { [K in Exclude<keyof I, keyof StdSignDoc>]: never; }>(base?: I | undefined): StdSignDoc;
    fromPartial<I_1 extends {
        ChainID?: string | undefined;
        fee?: Uint8Array | undefined;
        memo?: string | undefined;
        msg?: Uint8Array | undefined;
        entropy?: number | undefined;
    } & {
        ChainID?: string | undefined;
        fee?: Uint8Array | undefined;
        memo?: string | undefined;
        msg?: Uint8Array | undefined;
        entropy?: number | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof StdSignDoc>]: never; }>(object: I_1): StdSignDoc;
};
export declare const Coin: {
    encode(message: Coin, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Coin;
    fromJSON(object: any): Coin;
    toJSON(message: Coin): unknown;
    create<I extends {
        denom?: string | undefined;
        amount?: string | undefined;
    } & {
        denom?: string | undefined;
        amount?: string | undefined;
    } & { [K in Exclude<keyof I, keyof Coin>]: never; }>(base?: I | undefined): Coin;
    fromPartial<I_1 extends {
        denom?: string | undefined;
        amount?: string | undefined;
    } & {
        denom?: string | undefined;
        amount?: string | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof Coin>]: never; }>(object: I_1): Coin;
};
export declare const DecCoin: {
    encode(message: DecCoin, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): DecCoin;
    fromJSON(object: any): DecCoin;
    toJSON(message: DecCoin): unknown;
    create<I extends {
        denom?: string | undefined;
        amount?: string | undefined;
    } & {
        denom?: string | undefined;
        amount?: string | undefined;
    } & { [K in Exclude<keyof I, keyof DecCoin>]: never; }>(base?: I | undefined): DecCoin;
    fromPartial<I_1 extends {
        denom?: string | undefined;
        amount?: string | undefined;
    } & {
        denom?: string | undefined;
        amount?: string | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof DecCoin>]: never; }>(object: I_1): DecCoin;
};
export declare const MsgProtoStake: {
    encode(message: MsgProtoStake, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgProtoStake;
    fromJSON(object: any): MsgProtoStake;
    toJSON(message: MsgProtoStake): unknown;
    create<I extends {
        pubKey?: Uint8Array | undefined;
        chains?: string[] | undefined;
        value?: string | undefined;
    } & {
        pubKey?: Uint8Array | undefined;
        chains?: (string[] & string[] & { [K in Exclude<keyof I["chains"], keyof string[]>]: never; }) | undefined;
        value?: string | undefined;
    } & { [K_1 in Exclude<keyof I, keyof MsgProtoStake>]: never; }>(base?: I | undefined): MsgProtoStake;
    fromPartial<I_1 extends {
        pubKey?: Uint8Array | undefined;
        chains?: string[] | undefined;
        value?: string | undefined;
    } & {
        pubKey?: Uint8Array | undefined;
        chains?: (string[] & string[] & { [K_2 in Exclude<keyof I_1["chains"], keyof string[]>]: never; }) | undefined;
        value?: string | undefined;
    } & { [K_3 in Exclude<keyof I_1, keyof MsgProtoStake>]: never; }>(object: I_1): MsgProtoStake;
};
export declare const MsgBeginUnstake: {
    encode(message: MsgBeginUnstake, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgBeginUnstake;
    fromJSON(object: any): MsgBeginUnstake;
    toJSON(message: MsgBeginUnstake): unknown;
    create<I extends {
        Address?: Uint8Array | undefined;
    } & {
        Address?: Uint8Array | undefined;
    } & { [K in Exclude<keyof I, "Address">]: never; }>(base?: I | undefined): MsgBeginUnstake;
    fromPartial<I_1 extends {
        Address?: Uint8Array | undefined;
    } & {
        Address?: Uint8Array | undefined;
    } & { [K_1 in Exclude<keyof I_1, "Address">]: never; }>(object: I_1): MsgBeginUnstake;
};
export declare const MsgUnjail: {
    encode(message: MsgUnjail, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgUnjail;
    fromJSON(object: any): MsgUnjail;
    toJSON(message: MsgUnjail): unknown;
    create<I extends {
        AppAddr?: Uint8Array | undefined;
    } & {
        AppAddr?: Uint8Array | undefined;
    } & { [K in Exclude<keyof I, "AppAddr">]: never; }>(base?: I | undefined): MsgUnjail;
    fromPartial<I_1 extends {
        AppAddr?: Uint8Array | undefined;
    } & {
        AppAddr?: Uint8Array | undefined;
    } & { [K_1 in Exclude<keyof I_1, "AppAddr">]: never; }>(object: I_1): MsgUnjail;
};
export declare const MsgProtoNodeStake8: {
    encode(message: MsgProtoNodeStake8, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgProtoNodeStake8;
    fromJSON(object: any): MsgProtoNodeStake8;
    toJSON(message: MsgProtoNodeStake8): unknown;
    create<I extends {
        Publickey?: Uint8Array | undefined;
        Chains?: string[] | undefined;
        value?: string | undefined;
        ServiceUrl?: string | undefined;
        OutAddress?: Uint8Array | undefined;
        RewardDelegators?: {
            [x: string]: number | undefined;
        } | undefined;
    } & {
        Publickey?: Uint8Array | undefined;
        Chains?: (string[] & string[] & { [K in Exclude<keyof I["Chains"], keyof string[]>]: never; }) | undefined;
        value?: string | undefined;
        ServiceUrl?: string | undefined;
        OutAddress?: Uint8Array | undefined;
        RewardDelegators?: ({
            [x: string]: number | undefined;
        } & {
            [x: string]: number | undefined;
        } & { [K_1 in Exclude<keyof I["RewardDelegators"], string | number>]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, keyof MsgProtoNodeStake8>]: never; }>(base?: I | undefined): MsgProtoNodeStake8;
    fromPartial<I_1 extends {
        Publickey?: Uint8Array | undefined;
        Chains?: string[] | undefined;
        value?: string | undefined;
        ServiceUrl?: string | undefined;
        OutAddress?: Uint8Array | undefined;
        RewardDelegators?: {
            [x: string]: number | undefined;
        } | undefined;
    } & {
        Publickey?: Uint8Array | undefined;
        Chains?: (string[] & string[] & { [K_3 in Exclude<keyof I_1["Chains"], keyof string[]>]: never; }) | undefined;
        value?: string | undefined;
        ServiceUrl?: string | undefined;
        OutAddress?: Uint8Array | undefined;
        RewardDelegators?: ({
            [x: string]: number | undefined;
        } & {
            [x: string]: number | undefined;
        } & { [K_4 in Exclude<keyof I_1["RewardDelegators"], string | number>]: never; }) | undefined;
    } & { [K_5 in Exclude<keyof I_1, keyof MsgProtoNodeStake8>]: never; }>(object: I_1): MsgProtoNodeStake8;
};
export declare const MsgProtoNodeStake8_RewardDelegatorsEntry: {
    encode(message: MsgProtoNodeStake8_RewardDelegatorsEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgProtoNodeStake8_RewardDelegatorsEntry;
    fromJSON(object: any): MsgProtoNodeStake8_RewardDelegatorsEntry;
    toJSON(message: MsgProtoNodeStake8_RewardDelegatorsEntry): unknown;
    create<I extends {
        key?: string | undefined;
        value?: number | undefined;
    } & {
        key?: string | undefined;
        value?: number | undefined;
    } & { [K in Exclude<keyof I, keyof MsgProtoNodeStake8_RewardDelegatorsEntry>]: never; }>(base?: I | undefined): MsgProtoNodeStake8_RewardDelegatorsEntry;
    fromPartial<I_1 extends {
        key?: string | undefined;
        value?: number | undefined;
    } & {
        key?: string | undefined;
        value?: number | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof MsgProtoNodeStake8_RewardDelegatorsEntry>]: never; }>(object: I_1): MsgProtoNodeStake8_RewardDelegatorsEntry;
};
export declare const MsgBeginNodeUnstake8: {
    encode(message: MsgBeginNodeUnstake8, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgBeginNodeUnstake8;
    fromJSON(object: any): MsgBeginNodeUnstake8;
    toJSON(message: MsgBeginNodeUnstake8): unknown;
    create<I extends {
        Address?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & {
        Address?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & { [K in Exclude<keyof I, keyof MsgBeginNodeUnstake8>]: never; }>(base?: I | undefined): MsgBeginNodeUnstake8;
    fromPartial<I_1 extends {
        Address?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & {
        Address?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof MsgBeginNodeUnstake8>]: never; }>(object: I_1): MsgBeginNodeUnstake8;
};
export declare const MsgNodeUnjail: {
    encode(message: MsgNodeUnjail, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgNodeUnjail;
    fromJSON(object: any): MsgNodeUnjail;
    toJSON(message: MsgNodeUnjail): unknown;
    create<I extends {
        ValidatorAddr?: Uint8Array | undefined;
    } & {
        ValidatorAddr?: Uint8Array | undefined;
    } & { [K in Exclude<keyof I, "ValidatorAddr">]: never; }>(base?: I | undefined): MsgNodeUnjail;
    fromPartial<I_1 extends {
        ValidatorAddr?: Uint8Array | undefined;
    } & {
        ValidatorAddr?: Uint8Array | undefined;
    } & { [K_1 in Exclude<keyof I_1, "ValidatorAddr">]: never; }>(object: I_1): MsgNodeUnjail;
};
export declare const MsgNodeUnjail8: {
    encode(message: MsgNodeUnjail8, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgNodeUnjail8;
    fromJSON(object: any): MsgNodeUnjail8;
    toJSON(message: MsgNodeUnjail8): unknown;
    create<I extends {
        ValidatorAddr?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & {
        ValidatorAddr?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & { [K in Exclude<keyof I, keyof MsgNodeUnjail8>]: never; }>(base?: I | undefined): MsgNodeUnjail8;
    fromPartial<I_1 extends {
        ValidatorAddr?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & {
        ValidatorAddr?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof MsgNodeUnjail8>]: never; }>(object: I_1): MsgNodeUnjail8;
};
export declare const MsgSend: {
    encode(message: MsgSend, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgSend;
    fromJSON(object: any): MsgSend;
    toJSON(message: MsgSend): unknown;
    create<I extends {
        FromAddress?: Uint8Array | undefined;
        ToAddress?: Uint8Array | undefined;
        amount?: string | undefined;
    } & {
        FromAddress?: Uint8Array | undefined;
        ToAddress?: Uint8Array | undefined;
        amount?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgSend>]: never; }>(base?: I | undefined): MsgSend;
    fromPartial<I_1 extends {
        FromAddress?: Uint8Array | undefined;
        ToAddress?: Uint8Array | undefined;
        amount?: string | undefined;
    } & {
        FromAddress?: Uint8Array | undefined;
        ToAddress?: Uint8Array | undefined;
        amount?: string | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof MsgSend>]: never; }>(object: I_1): MsgSend;
};
export declare const MsgDAOTransfer: {
    encode(message: MsgDAOTransfer, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgDAOTransfer;
    fromJSON(object: any): MsgDAOTransfer;
    toJSON(message: MsgDAOTransfer): unknown;
    create<I extends {
        fromAddress?: Uint8Array | undefined;
        toAddress?: Uint8Array | undefined;
        amount?: string | undefined;
        action?: string | undefined;
    } & {
        fromAddress?: Uint8Array | undefined;
        toAddress?: Uint8Array | undefined;
        amount?: string | undefined;
        action?: string | undefined;
    } & { [K in Exclude<keyof I, keyof MsgDAOTransfer>]: never; }>(base?: I | undefined): MsgDAOTransfer;
    fromPartial<I_1 extends {
        fromAddress?: Uint8Array | undefined;
        toAddress?: Uint8Array | undefined;
        amount?: string | undefined;
        action?: string | undefined;
    } & {
        fromAddress?: Uint8Array | undefined;
        toAddress?: Uint8Array | undefined;
        amount?: string | undefined;
        action?: string | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof MsgDAOTransfer>]: never; }>(object: I_1): MsgDAOTransfer;
};
export declare const Upgrade: {
    encode(message: Upgrade, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Upgrade;
    fromJSON(object: any): Upgrade;
    toJSON(message: Upgrade): unknown;
    create<I extends {
        height?: number | undefined;
        version?: string | undefined;
        oldUpgradeHeight?: number | undefined;
        features?: string[] | undefined;
    } & {
        height?: number | undefined;
        version?: string | undefined;
        oldUpgradeHeight?: number | undefined;
        features?: (string[] & string[] & { [K in Exclude<keyof I["features"], keyof string[]>]: never; }) | undefined;
    } & { [K_1 in Exclude<keyof I, keyof Upgrade>]: never; }>(base?: I | undefined): Upgrade;
    fromPartial<I_1 extends {
        height?: number | undefined;
        version?: string | undefined;
        oldUpgradeHeight?: number | undefined;
        features?: string[] | undefined;
    } & {
        height?: number | undefined;
        version?: string | undefined;
        oldUpgradeHeight?: number | undefined;
        features?: (string[] & string[] & { [K_2 in Exclude<keyof I_1["features"], keyof string[]>]: never; }) | undefined;
    } & { [K_3 in Exclude<keyof I_1, keyof Upgrade>]: never; }>(object: I_1): Upgrade;
};
export declare const MsgUpgrade: {
    encode(message: MsgUpgrade, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgUpgrade;
    fromJSON(object: any): MsgUpgrade;
    toJSON(message: MsgUpgrade): unknown;
    create<I extends {
        address?: Uint8Array | undefined;
        upgrade?: {
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: string[] | undefined;
        } | undefined;
    } & {
        address?: Uint8Array | undefined;
        upgrade?: ({
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: string[] | undefined;
        } & {
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: (string[] & string[] & { [K in Exclude<keyof I["upgrade"]["features"], keyof string[]>]: never; }) | undefined;
        } & { [K_1 in Exclude<keyof I["upgrade"], keyof Upgrade>]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, keyof MsgUpgrade>]: never; }>(base?: I | undefined): MsgUpgrade;
    fromPartial<I_1 extends {
        address?: Uint8Array | undefined;
        upgrade?: {
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: string[] | undefined;
        } | undefined;
    } & {
        address?: Uint8Array | undefined;
        upgrade?: ({
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: string[] | undefined;
        } & {
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: (string[] & string[] & { [K_3 in Exclude<keyof I_1["upgrade"]["features"], keyof string[]>]: never; }) | undefined;
        } & { [K_4 in Exclude<keyof I_1["upgrade"], keyof Upgrade>]: never; }) | undefined;
    } & { [K_5 in Exclude<keyof I_1, keyof MsgUpgrade>]: never; }>(object: I_1): MsgUpgrade;
};
export declare const MsgChangeParam: {
    encode(message: MsgChangeParam, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgChangeParam;
    fromJSON(object: any): MsgChangeParam;
    toJSON(message: MsgChangeParam): unknown;
    create<I extends {
        FromAddress?: Uint8Array | undefined;
        paramKey?: string | undefined;
        paramVal?: Uint8Array | undefined;
    } & {
        FromAddress?: Uint8Array | undefined;
        paramKey?: string | undefined;
        paramVal?: Uint8Array | undefined;
    } & { [K in Exclude<keyof I, keyof MsgChangeParam>]: never; }>(base?: I | undefined): MsgChangeParam;
    fromPartial<I_1 extends {
        FromAddress?: Uint8Array | undefined;
        paramKey?: string | undefined;
        paramVal?: Uint8Array | undefined;
    } & {
        FromAddress?: Uint8Array | undefined;
        paramKey?: string | undefined;
        paramVal?: Uint8Array | undefined;
    } & { [K_1 in Exclude<keyof I_1, keyof MsgChangeParam>]: never; }>(object: I_1): MsgChangeParam;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
declare type KeysOfUnion<T> = T extends T ? keyof T : never;
export declare type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
//# sourceMappingURL=tx-signer.d.ts.map