/// <reference types="node" />
import { PosmintStdSignature } from '@pokt-network/amino-js/types/src/types/pocket';
/**
 * Represents a given signature for a Transaction
 */
export declare class TxSignature {
    readonly pubKey: Buffer;
    readonly signature: Buffer;
    private readonly PUBLIC_KEY_TYPE;
    /**
     * @param pubKey {Buffer} public key of the signer
     * @param signature {Buffer} the signature
     */
    constructor(pubKey: Buffer, signature: Buffer);
    /**
     * Encodes the object to it's Amino encodable form
     */
    toPosmintStdSignature(): PosmintStdSignature;
}
//# sourceMappingURL=tx-signature.d.ts.map